New lvs/lvsmaster and natgw/natgwlist nodespecs for onnode.
[vlendec/samba-autobuild/.git] / ctdb / tools / onnode
1 #!/bin/bash
2
3 # Run commands on CTDB nodes.
4
5 # See http://ctdb.samba.org/ for more information about CTDB.
6
7 # Copyright (C) Martin Schwenke  2008
8
9 # Based on an earlier script by Andrew Tridgell and Ronnie Sahlberg.
10
11 # Copyright (C) Andrew Tridgell  2007
12
13 # This program is free software; you can redistribute it and/or modify
14 # it under the terms of the GNU General Public License as published by
15 # the Free Software Foundation; either version 3 of the License, or
16 # (at your option) any later version.
17    
18 # This program is distributed in the hope that it will be useful,
19 # but WITHOUT ANY WARRANTY; without even the implied warranty of
20 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
21 # GNU General Public License for more details.
22    
23 # You should have received a copy of the GNU General Public License
24 # along with this program; if not, see <http://www.gnu.org/licenses/>.
25
26 prog=$(basename $0)
27
28 usage ()
29 {
30     cat >&2 <<EOF
31 Usage: onnode [OPTION] ... <NODES> <COMMAND> ...
32   options:
33     -c          Run in current working directory on specified nodes.
34     -o <prefix> Save standard output from each node to file <prefix>.<ip>
35     -p          Run command in parallel on specified nodes.
36     -q          Do not print node addresses (overrides -v).
37     -v          Print node address even for a single node.
38   <NODES>       "all", "ok" (or "healthy"), "con" (or "connected"),
39                 "rm" (or "recmaster"), "lvs" (or "lvsmaster"),
40                 "natgw" (or "natgwlist");
41                 or a node number (0 base); or
42                 list (comma separated) of <NODES>; or
43                 range (hyphen separated) of node numbers.
44 EOF
45     exit 1
46
47 }
48
49 invalid_nodespec ()
50 {
51     echo "Invalid <nodespec>" >&2 ; echo >&2
52     usage
53 }
54
55 # Defaults.
56 current=false
57 parallel=false
58 verbose=false
59 quiet=false
60 prefix=""
61
62 parse_options ()
63 {
64     # $POSIXLY_CORRECT means that the command passed to onnode can
65     # take options and getopt won't reorder things to make them
66     # options ot onnode.
67     local temp=$(POSIXLY_CORRECT=1 getopt -n "$prog" -o "cho:pqv" -l help -- "$@")
68
69     [ $? != 0 ] && usage
70
71     eval set -- "$temp"
72
73     while true ; do
74         case "$1" in
75             -c) current=true ; shift ;;
76             -o) prefix="$2" ; shift 2 ;;
77             -p) parallel=true ; shift ;;
78             -q) quiet=true ; shift ;;
79             -v) verbose=true ; shift ;;
80             --) shift ; break ;;
81             -h|--help|*) usage ;; # Shouldn't happen, so this is reasonable.
82         esac
83     done
84
85     [ $# -lt 2 ] && usage
86
87     nodespec="$1" ; shift
88     command="$@"
89 }
90
91 echo_nth ()
92 {
93     local n="$1" ; shift
94
95     shift $n
96     local node="$1"
97
98     if [ -n "$node" ] ; then
99         echo $node
100     else
101         echo "${prog}: \"node ${n}\" does not exist" >&2
102         exit 1
103     fi
104 }
105
106 parse_nodespec ()
107 {
108     # Subshell avoids hacks to restore $IFS.
109     (
110         IFS=","
111         for i in $1 ; do
112             case "$i" in
113                 *-*) seq "${i%-*}" "${i#*-}" 2>/dev/null || invalid_nodespec ;;
114                 # Separate lines for readability.
115                 all|ok|healthy|con|connected) echo "$i" ;;
116                 rm|recmaster|lvs|lvsmaster|natgw|natgwlist) echo "$i" ;;
117                 *)
118                     [ $i -gt -1 ] 2>/dev/null || invalid_nodespec
119                     echo $i
120             esac
121         done
122     )
123 }
124
125 ctdb_status_output="" # cache
126 get_nodes_with_status ()
127 {
128     local all_nodes="$1"
129     local status="$2"
130
131     local bits
132     case "$status" in
133         healthy)
134             bits="0:0:0:0"
135             ;;
136         connected)
137             bits="0:[0-1]:[0-1]:[0-1]"
138             ;;
139         *)
140             invalid_nodespec
141     esac
142
143     if [ -z "$ctdb_status_output" ] ; then
144         # FIXME: need to do something if $CTDB_NODES_SOCKETS is set.
145         ctdb_status_output=$(ctdb -Y status 2>/dev/null)
146         if [ $? -ne 0 ] ; then
147             echo "${prog}: unable to get status of CTDB nodes" >&2
148             exit 1
149         fi
150         ctdb_status_output="${ctdb_status_output#* }"
151     fi
152
153     local nodes=""
154     local i
155     for i in $ctdb_status_output ; do
156         # Try removing bits from end.
157         local t="${i%:${bits}:}"
158         if [ "$t" != "$i" ] ; then
159             # Succeeded.  Get address.  NOTE: this is an optimisation.
160             # It might be better to get the node number and then get
161             # the nth node to get the address.  This would make things
162             # more consistent if /etc/ctdb/nodes actually contained
163             # hostnames.
164             nodes="${nodes} ${t##*:}"
165         fi
166     done
167
168     echo $nodes
169 }
170
171 ctdb_props="" # cache
172 get_node_with_property ()
173 {
174     local all_nodes="$1"
175     local prop="$2"
176
177     local prop_node=""
178     if [ "${ctdb_props##:${prop}:}" = "$ctdb_props" ] ; then
179         prop_node=$(ctdb "$prop" 2>/dev/null)
180         if [ $? -eq 0 ] ; then
181             ctdb_props="${ctdb_props}${ctdb_props:+ }:${prop}:${prop_node}"
182         else
183             prop_node=""
184         fi
185     else
186         prop_node="${ctdb_props##:${prop}:}"
187         prop_node="${prop_node%% *}"
188     fi
189     if [ -n "$prop_node" ] ; then
190         echo_nth "$prop_node" $all_nodes
191     else
192         echo "${prog}: No ${prop} available" >&2
193         exit 1
194     fi
195 }
196
197 get_nodes ()
198 {
199     local all_nodes
200
201     if [ -n "$CTDB_NODES_SOCKETS" ] ; then 
202         all_nodes="$CTDB_NODES_SOCKETS"
203     else
204         [ -f "$CTDB_NODES_FILE" ] || CTDB_NODES_FILE=/etc/ctdb/nodes
205         all_nodes=$(egrep '^[[:alnum:]]' $CTDB_NODES_FILE)
206     fi
207
208     local nodes=""
209     local n
210     for n in $(parse_nodespec "$1") ; do
211         [ $? != 0 ] && exit 1  # Required to catch exit in above subshell.
212         case "$n" in
213             all)
214                 echo $all_nodes ;;
215             ok|healthy) 
216                 get_nodes_with_status "$all_nodes" "healthy" || exit 1
217                 ;;
218             con|connected) 
219                 get_nodes_with_status "$all_nodes" "connected" || exit 1
220                 ;;
221             rm|recmaster)
222                 get_node_with_property "$all_nodes" "recmaster" || exit 1
223                 ;;
224             lvs|lvsmaster)
225                 get_node_with_property "$all_nodes" "lvsmaster" || exit 1
226                 ;;
227             natgw|natgwlist)
228                 get_node_with_property "$all_nodes" "natgwlist" || exit 1
229                 ;;
230             *)
231                 echo_nth $n $all_nodes
232         esac
233         
234     done
235 }
236
237 fakessh ()
238 {
239     CTDB_SOCKET="$1" sh -c "$2"
240 }
241
242 stdout_filter ()
243 {
244     if [ -n "$prefix" ] ; then
245         cat >"${prefix}.${n}"
246     elif $verbose && $parallel ; then
247         sed -e "s@^@[$n] @"
248     else
249         cat
250     fi
251 }
252
253 stderr_filter ()
254 {
255     if $verbose && $parallel ; then
256         sed -e "s@^@[$n] @"
257     else
258         cat
259     fi
260 }
261
262 ######################################################################
263
264 parse_options "$@"
265
266 $current && command="cd $PWD && $command"
267
268 ssh_opts=
269 if [ -n "$CTDB_NODES_SOCKETS" ] ; then
270     SSH=fakessh
271 else 
272     # Could "2>/dev/null || true" but want to see errors from typos in file.
273     [ -r /etc/ctdb/onnode.conf ] && . /etc/ctdb/onnode.conf
274     [ -n "$SSH" ] || SSH=ssh
275     if [ "$SSH" = "ssh" ] ; then
276         ssh_opts="-n"
277     else
278         : # rsh? All bets are off!
279     fi
280 fi
281
282 ######################################################################
283
284 nodes=$(get_nodes "$nodespec")
285 [ $? != 0 ] && exit 1   # Required to catch exit in above subshell.
286
287 if $quiet ; then
288     verbose=false
289 else
290     # If $nodes contains a space or a newline then assume multiple nodes.
291     nl="
292 "
293     [ "$nodes" != "${nodes%[ ${nl}]*}" ] && verbose=true
294 fi
295
296 pids=""
297 trap 'kill -TERM $pids 2>/dev/null' INT TERM
298 # There's a small race here where the kill can fail if no processes
299 # have been added to $pids and the script is interrupted.  However,
300 # the part of the window where it matter is very small.
301 retcode=0
302 for n in $nodes ; do
303     set -o pipefail 2>/dev/null
304     if $parallel ; then
305         { exec 3>&1 ; { $SSH $ssh_opts $EXTRA_SSH_OPTS $n "$command" | stdout_filter >&3 ; } 2>&1 | stderr_filter ; } &
306         pids="${pids} $!"
307     else
308         if $verbose ; then
309             echo >&2 ; echo ">> NODE: $n <<" >&2
310         fi
311
312         { exec 3>&1 ; { $SSH $ssh_opts $EXTRA_SSH_OPTS $n "$command" | stdout_filter >&3 ; } 2>&1 | stderr_filter ; }
313         [ $? = 0 ] || retcode=$?
314     fi
315 done
316
317 $parallel && {
318     for p in $pids; do
319         wait $p
320         [ $? = 0 ] || retcode=$?
321     done
322 }
323
324 exit $retcode